# $Id: challenge.tcl 1520 2008-10-17 17:16:09Z sergei $
#
# Robot challenge support (XEP-0158)
#

namespace eval challenge {}

###############################################################################

proc challenge::process_x {rowvar bodyvar f x xlib from id type replyP} {
    upvar 2 $rowvar row
    upvar 2 $bodyvar body

    set challenge 0
    foreach xa $x {
	::xmpp::xml::split $xa tag xmlns attrs cdata subels

	if {$xmlns != $::NS(challenge)} continue

	set challenge 1
	foreach subel $subels {
	    ::xmpp::xml::split $subel stag sxmlns sattrs scdata ssubels

	    if {$sxmlns == $::NS(data) && [llength $ssubels] > 0} {
		if {[catch {process_x_data $f $xlib $from $subel}]} {
		    # Cannot process challenge form, so falling back to a
		    # legacy challenge method if any.
		    # TODO: Show error message to user.
		    set challenge 0
		}
	    }
	}
    }
    if {!$challenge} {
	return
    } else {
	set body ""
	return stop
    }
}

hook::add message_process_x_hook [namespace current]::challenge::process_x 10

proc challenge::process_x_data {f xlib from x} {
    data::draw_window [list $x] [list [namespace current]::send_x_data $xlib $from]
}

proc challenge::send_x_data {xlib to w restags} {
    ::xmpp::sendIQ $xlib set \
	[::xmpp::xml::create challenge \
		    -xmlns $::NS(challenge) \
		    -subelements $restags] \
	-to $to
    destroy $w
}

