# $Id: roster_delimiter.tcl 1520 2008-10-17 17:16:09Z sergei $
#
# Nested roster groups server-side delimiter storing (XEP-0083).
#

###############################################################################

namespace eval delimiter {}

###############################################################################
#
# Retrieving nested groups delimiter
#

proc delimiter::request {xlib fallback args} {
    debugmsg plugins "delimiter::request $xlib $fallback $args"
    
    set command ""
    foreach {key val} $args {
	switch -- $key {
	    -command { set command $val }
	}
    }

    private::retrieve $xlib [list [::xmpp::xml::create roster \
					    -xmlns $::NS(delimiter)]] \
	-command [list [namespace current]::request_result \
		       $xlib $fallback $command]
}

proc delimiter::request_result {xlib fallback command status xml} {
    debugmsg plugins "delimiter::request_result $xlib $status"

    set delimiter $fallback

    if {$status == "ok"} {
	foreach item $xml {
	    ::xmpp::xml::split $item tag xmlns attrs cdata subels

	    if {$xmlns == $NS(delimiter)} {
		set delimiter $cdata
	    }
	}
    }

    if {$command != ""} {
	eval $command [list $xlib $delimiter]
    }
}

###############################################################################
#
# Storing nested groups delimiter
#

proc delimiter::store {xlib delimiter args} {
    debugmsg plugins "delimiter::store $xlib $delimiter $args"

    set command ""
    foreach {key val} $args {
	switch -- $key {
	    -command { set command $val }
	}
    }

    private::store $xlib [list [::xmpp::xml::create roster \
					-xmlns $::NS(delimiter) \
					-cdata $delimiter]] \
	-command [list [namespace current]::store_result $xlib $command]
}

proc delimiter::store_result {xlib command status xml} {
    debugmsg plugins "delimiter::store_result $xlib $status"
    
    if {$command != ""} {
	eval $command [list $status $xml]
    }
}

