# $Id: private.tcl 1520 2008-10-17 17:16:09Z sergei $
#
# Private XML Storage (XEP-0049) support
#

namespace eval private {}

proc private::store {xlib query args} {
    set command ""
    foreach {key val} $args {
	switch -- $key {
	    -command { set command $val }
	}
    }

    ::xmpp::sendIQ $xlib set \
	-query [::xmpp::xml::create query \
			-xmlns $::NS(private) \
			-subelements $query] \
	-command [list [namespace current]::store_result $command]
}

proc private::store_result {command status xml} {
    if {$command != ""} {
	uplevel #0 $command [list $status $xml]
    }
}

proc private::retrieve {xlib query args} {
    set command ""
    foreach {key val} $args {
	switch -- $key {
	    -command { set command $val }
	}
    }

    ::xmpp::sendIQ $xlib get \
	-query [::xmpp::xml::create query \
			-xmlns $::NS(private) \
			-subelements $query] \
	-command [list [namespace current]::retrieve_result $command]
}

proc private::retrieve_result {command status xml} {
    if {$command == ""} return

    if {$status != "ok"} {
	uplevel #0 $command [list $status $xml]
	return
    }

    ::xmpp::xml::split $xml tag xmlns attrs cdata subels

    uplevel #0 $command [list ok $subels]
}

